﻿// Insert FileName - Adobe Photoshop Script
// Description: creates text layer with current FileName as text. Option includes 
//  1. include path to the current file
//  2. include file extension 
//  3. size of font in pixel
// Requirements: Adobe Photoshop CS3, or higher
// Version: 0.0.1 -  06/Apr/2015
// Author: Anil Tejwani (anil@tejwani.com)
// Website: http://tejwani.com/
// ============================================================================
// Installation:
// 1. Place script in:
//    PC(32):  C:\Program Files (x86)\Adobe\Adobe Photoshop CS#\Presets\Scripts\
//    PC(64):  C:\Program Files\Adobe\Adobe Photoshop CS# (64 Bit)\Presets\Scripts\
// 2. Restart Photoshop
// 3. Choose File > Scripts > TS Insert FileName
// ============================================================================

// enable double-clicking from Mac Finder or Windows Explorer
#target photoshop

// bring application forward for double-click events
app.bringToFront();

if ( documents.length > 0 ){prefs = setPreferences(); main()}else{alert("ERROR!!!!!\nSeems we dont have any file open. \nNothing to do. :) \nOpen a file and try again.")}

function setPreferences(){
     var prefs = new Object();
    /* EDIT STARTS HERE */
    prefs.textFromBottom = 20; 
    prefs.startOffsetFromLeft = 20; 
    prefs.fontSize = '25px'; 
    /* EDIT ENDS HERE */
    prefs.incPath =  true;prefs.incExt =  true;  prefs.originalDialogMode = app.displayDialogs;prefs.originalRulerUnits = preferences.rulerUnits; app.displayDialogs = DialogModes.ERROR;	preferences.rulerUnits = Units.PIXELS;
    return prefs;
}    

function process(){var origDoc = activeDocument;var fullName = origDoc.name; if(!prefs.incExt){fullName = fullName.replace(/(?:\.[^.]*$|$)/, ''); }if(prefs.incPath){fullName = origDoc.path.toString() + "  :: " + fullName;}var myLayerRef = origDoc.artLayers.add();myLayerRef.kind = LayerKind.TEXT;myLayerRef.name = fullName;var myTextRef = myLayerRef.textItem;myTextRef.position = new Array( prefs.startOffsetFromLeft, origDoc.height - prefs.textFromBottom );myTextRef.size = prefs.fontSize; myTextRef.contents = myLayerRef.name;}
function main(){try{setOptions();process();}catch( e ){/* An error occurred. Restore ruler units, then propagate the error back to the user */preferences.rulerUnits = prefs.originalRulerUnits;app.displayDialogs = prefs.originalDialogMode;throw e;}}
function setOptions(){
      #target estoolkit
    var win, windowResource;windowResource = "dialog {  orientation: 'column', alignChildren: ['fill', 'top'],  preferredSize:[350, 180], text: 'Photoshop Script - Insert FileName (TextLayer)',  margins:10, settingPanel: Group { orientation: 'column',fontSize: Group { st4: StaticText { text: 'Select Font Size:' }, sl: Slider { minvalue: 10, maxvalue: 50, value: 25, size:[200,20] }, quality: StaticText { text: '25px', characters: 4} },incPath: Checkbox { text:'Include Path', value: true }, incExt: Checkbox { text:'Include Extension', value: true}, applyButton: Button { text: 'Insert»', properties:{name:'ok'},size:[350,30] , weight:bold }, dummy:StaticText { text: '' },alignChildren: 'left',} creditGroup: Group { orientation: 'row', alignChildren: 'right', linkText:StaticText { text: 'Visit us: www.tejwani.com/photoshop-scripting/' }, } }"
    win = new Window(windowResource); /* listen and update text box */ win.settingPanel.fontSize.sl.onChange = function() {win.settingPanel.fontSize.quality.text = Math.round(this.value) + 'px';}
    /* apply button */win.settingPanel.applyButton.onClick = function() {prefs.fontSize = win.settingPanel.fontSize.quality.text;prefs.incPath =  win.settingPanel.incPath.value;prefs.incExt =  win.settingPanel.incExt.value;        return win.close();};
    win.creditGroup.linkText.onClick = function() {File(app.path.toString() + "/Presets/Scripts/TS-insert-filename.html").execute();};win.show();    
}